# def test():
# 	print("utils function!")
import numpy as np
import random as ra

def list_is_matrix(x):
	# x : list
	#---------------------------
	# returns True if
	#   x has m x n shape
	#   [[1,2],[3,4]] is a matrix, but [[1,2],[3]] is not
	# Assume 2 dimensional. (TODO)
	#   Cannot distinguish non numerical entry
	#   for example [[1,2],[3,[]]] returns true (but should not)
	
	is_matrix = True

	row_size = len(x)
	# Assume x is not empty
	col_size = len(x[0])
	
	for i in range(1,len(x)):
		# print(i,":",x[i])
		temp = len(x[i])
		if temp != col_size:
			return False, -1, -1
	return is_matrix, row_size, col_size

def print_numpy_matrix(np_mat,formatting="%6.2f",no_of_space=20):
	if formatting is None:
		print(np_mat)
	else:
		n_row, n_col = np_mat.shape
		for i in range(n_row):
			for j in range(n_col):
				if j==0:
					for k in range(no_of_space):
						print(" ",end="")
				print(formatting% (np_mat.item(i,j)),end=" ")
			print("")

def partition_list(x, partition, do_shuffle=False,
	verbose=False,
	for_index=False):
	
	# if partition is set to integer, then each batch size is the size of the integer
	#   for example partition=3 to list=[1,2,3,4,5,6,7] will yield [[1,2,3],[4,5,6],[7,8]]
	# otherwise, partition is a list of list [ind1, ind2, ..., indN]
	#   where ind is a list of indices
	#   for example, partition = [[2,1],[3]] for list=[x,y,z] will yield [[y,x],[z]]
	index_partition = None
	collection_of_batches = []
	if verbose>20: print(" > partition_list()")
	if type(partition) ==type(1):
		indices = np.array(range(len(x)))
		
		if do_shuffle:
			ra.shuffle(indices)
			if verbose>20: 
				print("   indices = ",indices)
				print("   indices shuffled = ",indices)
			temp = [x[indices[i]] for i in range(len(x))]
			x = temp
		this_batch = []
		count = 0
		N = len(x)
		for i in range(N):
			this_batch.append(x[i])
			count = count + 1
			if (count == partition) or (i==N-1):
				collection_of_batches.append(this_batch)
				this_batch = []
				count = 0
		if not for_index:
			index_partition, _ = partition_list(indices, partition, do_shuffle=False,for_index=True)
	else: # it must be list of list
		if verbose>20:
			print("   indices = ",indices) 
			print("   manual index.")
		for j in range(len(partition)):
			index_batch = partition[j]
			this_batch = []
			for i in index_batch:
				this_batch.append(x[i])
			collection_of_batches.append(this_batch)
	return collection_of_batches , index_partition


def numpy_matrix_to_list(np_mat):
	# np_mat : numpy matrix
	n_row, n_col = np_mat.shape
	# print(" n_row, n_col = ",n_row,",", n_col)

	out = []
	for i in range(n_row):
		this_row = []
		for j in range(n_col):
			this_row.append(np_mat.item(i,j))
		out.append(this_row)
	return out